Package: GSEAmining
Type: Package
Title: Make Biological Sense of Gene Set Enrichment Analysis Outputs
Version: 1.20.0
Authors@R: person("Oriol", "Arqués", email = "oriol.arques@gmail.com",
                  role = c("aut", "cre")) 
Description: Gene Set Enrichment Analysis is a very powerful and interesting 
  computational method that allows an easy correlation between differential 
  expressed genes and biological processes. Unfortunately, although it was 
  designed to help researchers to interpret gene
  expression data it can generate huge amounts of results whose biological 
  meaning can be difficult to interpret. 
  Many available tools rely on the hierarchically structured Gene Ontology (GO) 
  classification to reduce reundandcy in the results. However, due to the 
  popularity of GSEA many more gene set collections, such as those in the 
  Molecular Signatures Database are emerging. Since these collections 
  are not organized as those in GO, their usage for GSEA do not always give a 
  straightforward answer or, in other words, getting all the meaninful 
  information can be challenging with the currently available tools. For these 
  reasons, GSEAmining was born to be an easy tool to create reproducible reports 
  to help researchers make biological sense of GSEA outputs.
  Given the results of GSEA, GSEAmining clusters the different gene sets 
  collections based on the presence of the same genes in the leadind edge 
  (core) subset. Leading edge subsets are those genes that contribute most to
  the enrichment score of each collection of genes or gene sets. For this 
  reason, gene sets that participate in similar biological processes should 
  share genes in common and in turn cluster together. After that, GSEAmining is 
  able to identify and represent for each cluster: 
  - The most enriched terms in the names of gene sets (as wordclouds)
  - The most enriched genes in the leading edge subsets (as bar plots).
  In each case, positive and negative enrichments are shown in different colors 
  so it is easy to distinguish biological processes or genes that may be of 
  interest in that particular study.
License: GPL-3 | file LICENSE
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.0
Imports: dplyr, tidytext, dendextend, tibble, ggplot2, ggwordcloud,
        stringr, gridExtra, rlang, grDevices, graphics, stats, methods
Depends: R (>= 4.0)
Suggests: knitr, rmarkdown, BiocStyle, clusterProfiler, testthat, tm
VignetteBuilder: knitr
biocViews: GeneSetEnrichment, Clustering, Visualization
git_url: https://git.bioconductor.org/packages/GSEAmining
git_branch: RELEASE_3_22
git_last_commit: b5d7a90
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 04:21:29 UTC; biocbuild
Author: Oriol Arqués [aut, cre]
Maintainer: Oriol Arqués <oriol.arques@gmail.com>

#' @title gm_dendplot: GSEAmining dendrogram plotter
#'
#' @description Takes the output of gm_clust, which is an hclust class object,
#' and plots the dendrogram using the dendextend package.
#'
#' @param df Data frame that contains at least three columns: an ID column for
#' the gene set names, a NES column with the normalized enrichment score and a
#' core_enrichment column containing the genes in the leading edge of each
#' gene set separated by '/'.
#' @param hc The output of gm_clust, which is an hclust class object.
#' @param col_pos Color to represent the positively enriched gene sets. Default
#' is red.
#' @param col_neg Color to represent the negatively enriched gene sets. Default
#' is blue.
#' @param dend_len An integer that defines the length of the dendrogram. Default
#' value is 30. The closest to zero the longest the dendrogram.
#' @param rect A logical value indicating if rectangles should be drawn around
#' the clusters to help differentiating them. By default it is set to TRUE.
#' @param rect_len An integer to specify the length of the rectangle around the
#' cluster and the gene set label. Default is 2. The closest to zero the
#' smallest the rectangle.
#'
#' @return Invisibly returns a list with all the elements necessary to plot
#' a dendrogram.
#'
#' @export
#'
#' @import tibble
#' @import dendextend
#' @importFrom methods is
#'
#' @examples
#' data(genesets_sel)
#' gs.cl <- gm_clust(genesets_sel)
#' gm_dendplot(genesets_sel, gs.cl)
#'
gm_dendplot <- function(df,
                        hc,
                        col_pos = 'red',
                        col_neg ='blue',
                        dend_len = 30,
                        rect = TRUE,
                        rect_len = 2) {

  stopifnot(is.data.frame(df) | methods::is(hc, 'hclust'))

  # Convert hc in a dendrogram object to be visualized by dendextend
  dend <- hc %>% stats::as.dendrogram()

  # Color of the labels: Red=positively enriched / Blue = negatively enriched
  #   Get the order of the genesets in the cluster
  dend_order <- hc$labels[hc$order]

  # Create an object from geneset table and assign the color ------------------
  #   depending if NES < | > 0
  dend_label_col <- df %>%
    select(.data$ID, .data$NES) %>%
    mutate(color = ifelse(.data$NES > 0, col_pos, col_neg))

  #   Order the rows by the order of the genesets in the cluster
  dend_label_col <- dend_label_col[match(dend_order,
                                         dend_label_col$ID),]
  #   Keep only the value of color
  dend_label_col <- dend_label_col$color

  # Color of the clusters -----------------------------------------------------
  #   Red=positively enriched / Blue = negatively enriched
  #   Identify to which cluster each geneset belongs to
  dend_clust_col <- data.frame(cluster=cutree(hc, h = 0.999))

  #   Get rownames to geneset column
  dend_clust_col <- dend_clust_col %>%
    rownames_to_column('geneset')

  # Join the cluster column to the geneset table
  dend_clust_col <- dend_clust_col%>%
    left_join(df, by=c('geneset'='ID')) %>%
    select(.data$geneset, .data$NES, .data$cluster) %>%
    # Define the color that each geneset has depending on NES
    mutate(color = ifelse(.data$NES > 0, col_pos, col_neg))


  # Get the order of the genesets in the cluster
  dend_clust_col <- dend_clust_col[match(dend_order,
                                           dend_clust_col$geneset),] %>%
    # Since positive and negative genesets cluster together eliminate duplicates
    select(.data$cluster, .data$color) %>%
    unique()

  # Plot the clusters   -------------------------------------------------------
  graphics::par(mar = c(5.1,2,2,dend_len)) # set the margins
  dend %>%
    set("labels_cex", 0.45) %>%
    set('labels_col', dend_label_col) %>%
    set('branches_k_color', value = dend_clust_col$color,
        k = length(dend_clust_col[,1])) %>%
    plot(horiz = TRUE)

  # Add rectangles to differentiate better the clusters -----------------------
  if(rect == TRUE){
    dend %>%
      rect.dendrogram(k = length(dend_clust_col[,1]),
                      which = seq(from = 1,
                                  to = length((dend_clust_col[,1])),
                                  by = 2),
                      border = 0,
                      col = grDevices::rgb(red = 0.1,
                                           green =  0.2,
                                           blue =  0.4,
                                           alpha = 0.1),
                      lower_rect = -rect_len,
                      horiz = TRUE)
  }
}

#' @title clust_group_cores
#'
#' @description Takes the output of clust_groups, a data frame , and process
#' it to obtain the enrichment of genes in the core enrichment (or leading
#' edge analysis) within each cluster. The output is used in the functions
#' gm_enrichcores and gm_enrichreport.
#'
#' @param cg A data frame output from the GSEAmining clusts_groups function.
#' @param top An integer to choose the top most enriched genes to plot per
#' cluster. The default parameter are the top 3.
#'
#' @return A tibble with four variables (Cluster, Enrichment, lead_token, n).
#'
#' @export
#'
#' @examples
#' data(genesets_sel)
#' gs.cl <- gm_clust(genesets_sel)
#' clust.groups <- clust_groups(genesets_sel, gs.cl)
#' clust.lead <- clust_group_cores(clust.groups, top = 3)
#'
clust_group_cores <- function(cg,
                              top = 3) {
  # Obtain core enrichment terms of each gene set -----------------------------
  clust_lead <- cg %>%
    mutate(Enrichment = ifelse(.data$NES > 0, 'Pos', 'Neg')) %>%
    # separate the words of the core enrichment
    mutate(core_enrichment = str_replace_all(.data$core_enrichment,
                                             pattern='/',
                                             replacement = ' ')) %>%
    # create gene word tokens (one row per word)
    tidytext::unnest_tokens(.data$lead_token,
                            .data$core_enrichment,
                            token = 'ngrams',
                            n = 1,
                            to_lower = FALSE) %>%
    # eliminate tokens that are just numbers
    filter(!grepl('^\\d', .data$lead_token)) %>%
    # group by cluster and count how many words
    group_by(.data$Cluster, .data$Enrichment) %>%
    count(.data$lead_token, sort = TRUE) %>%
    # Select top n most common leading edge genes per cluster
    arrange(.data$Cluster) %>%
    top_n(n = top)

}

library("GSEAmining")
data(genesets_sel)

test_that("Test that clust_groups, clust_group_terms and clust_group_cores
          produce data.frames with necessary variables", {

  gs.filt <- gm_filter(genesets_sel,
                       p.adj = 0.05,
                       neg_NES = 2.6,
                       pos_NES = 2)
  gs.cl <- gm_clust(gs.filt)

  cg <- clust_groups(genesets_sel, gs.cl)
  cg_t <- clust_group_terms(cg)
  cg_c <- clust_group_cores(cg)


  expect_equal(class(cg), 'data.frame')
  expect_equal(names(cg),
               c("ID", "Cluster", "NES", "p.adjust", "core_enrichment"))
  expect_equal(names(cg_t),
               c("Cluster", "Enrichment", "monogram", "n"))
  expect_equal(names(cg_c),
               c("Cluster", "Enrichment", "lead_token", "n"))

})

#' @title gm_enrichreport: GSEAmining Enrichment Report
#'
#' @description Takes the output of gm_clust, which is an hclust class object,
#' and creates a report in pdf that contains enriched terms and enriched core
#' genes in gene sets for each cluster. The results of each cluster are plotted
#' in an independent page.
#'
#' @param df Data frame that contains at least three columns: an ID column for
#' the gene set names, a NES column with the normalized enrichment score and a
#' core_enrichment column containing the genes in the leading edge of each
#' gene set separated by '/'.
#' @param hc The output of gm_clust, which is an hclust class object.
#' @param col_pos Color to represent positively enriched gene sets. Default
#' is red.
#' @param col_neg Color to represent negatively enriched gene sets. Default
#' is blue.
#' @param top An integer to choose the top most enriched genes to plot per
#' cluster. The default parameter are the top 3.
#' @param output A string to name the output pdf file.
#'
#' @return  Generates a pdf file.
#'
#' @export
#'
#' @importFrom gridExtra marrangeGrob
#'
#' @examples
#' data(genesets_sel)
#' gs.cl <- gm_clust(genesets_sel)
#' \dontrun{gm_enrichreport(genesets_sel, gs.cl)}
#'
gm_enrichreport <- function(df,
                            hc,
                            col_pos = 'red',
                            col_neg = 'blue',
                            top = 3,
                            output = 'gm_report') {

  stopifnot(is.data.frame(df) | methods::is(hc, 'hclust'))

  # 1. Get the cluster groups from  gm_clust object ---------------------------
  clust.groups <- clust_groups(df, hc)

  # 2. Obtain the terms of each gene set --------------------------------------
  clust.wc <- clust_group_terms(clust.groups)

  # 3. Obtain core enrichment terms of each gene set --------------------------
  clust.lead <- clust_group_cores(clust.groups, top)

  # 4. Put together gene set terms and core terms -----------------------------
  # Create a list containing ggplot wordcloud for enriched terms

  cgw <- list() # cgw: cluster.groups.wordclouds

  for(i in seq_along(unique(clust.groups$Cluster))){

    cgw[[i]] <- ggplot(clust.wc %>% filter(.data$Cluster == i),
                       aes(label = .data$monogram,
                           size = .data$n,
                           col = .data$Enrichment))+
      ggwordcloud::geom_text_wordcloud_area(eccentricity = 1,
                               area_corr_power = 1) +
      scale_size_area(max_size = 8)+ #max size the biggest word can have
      scale_color_manual(values = ifelse(
        clust.wc$Enrichment[clust.wc$Cluster==i][1] == 'Pos',
                                         col_pos, col_neg))+
      labs(title = paste0('Cluster ', clust.wc$Cluster[clust.wc$Cluster==i][1],
                    '\n Enrichment: ',
                    ifelse(clust.wc$Enrichment[clust.wc$Cluster==i][1] == 'Pos',
                      'Positive', 'Negative')),
           subtitle = 'Gene Set Terms Enriched') +
      theme_minimal() +
      theme(plot.title = element_text(hjust = 0.5),
            plot.subtitle = element_text(hjust = 0.07))
  }

  # Create a list containing ggplot barplots for core enrichment
  cgc <- list() # cgc: cluster.groups.core

  for(i in seq_along(unique(clust.groups$Cluster))){

    cgc[[i]] <- ggplot(clust.lead %>% filter(.data$Cluster == i),
                              aes(x = stats::reorder(.data$lead_token, .data$n),
                                  y = .data$n,
                                  fill = .data$Enrichment))+
      geom_bar(stat = 'identity') +
      ylim(0,max(clust.lead$n) + 1)+
      coord_flip()+
      scale_fill_manual(values = ifelse(clust.lead$Enrichment[
        clust.lead$Cluster==i][1] == 'Pos', col_pos, col_neg))+
      labs(title = '',
           subtitle = 'Top Genes in Leading Edge Analysis')+
      ylab('Num of Gene Appearances in Different Genesets')+
      theme_minimal() +
      theme(plot.subtitle = element_text(hjust = 0),
            axis.title.y = element_blank(),
            legend.position = 'none')
  }


  # Merge both tables (genesets wordcloud and leading edge of each geneset)
  # Intercalating each element wordcloud1, core1, wordcloud2, core2, ...
  plots <- c(rbind(cgw, cgc))

  # Save each combination of geneset wordcloud and leading edge in one page
  report <- marrangeGrob(grobs = plots,
                                   nrow = 2,
                                   ncol = 1,
                                   top = NULL)
  ggsave(paste0(output, '.pdf'), report)

}

#' @title clust_group_terms
#'
#' @description Takes the output of clust_groups, a data frame , and process
#' it to obtain the enrichment of terms in gene sets names within each cluster.
#' The output is used in the functions gm_enrichterms and gm_enrichreport.
#'
#' @param cg A data frame output from the GSEAmining cluster_groups function.
#'
#' @return  A tibble with four variables (Cluster, Enrichment, monogram, n).
#'
#' @export
#'
#' @examples
#' data(genesets_sel)
#' gs.cl <- gm_clust(genesets_sel)
#' clust.groups <- clust_groups(genesets_sel, gs.cl)
#' clust.groups.wordcloud <- clust_group_terms(clust.groups)
#'
clust_group_terms <- function(cg) {
  # Obtain the terms of each gene set -----------------------------------------
  stop.words <- stop_words()

  clust_groups_wordcloud <- cg %>%
    mutate(Enrichment = ifelse(test = .data$NES > 0,
                               yes= 'Pos',
                               no = 'Neg')) %>%
    # separate the words of the geneset
    mutate(ID2 = str_replace_all(.data$ID,
                                 pattern='_',
                                 replacement = ' ')) %>%
    # eliminate the first word of the geneset
    mutate(ID2 = word(.data$ID2,
                      start = 2,
                      end = -1)) %>%
    # create word tokens (one row per word)
    tidytext::unnest_tokens(.data$monogram,
                            .data$ID2,
                            token = 'ngrams',
                            n = 1,
                            to_lower = FALSE) %>%
    # eliminate words like UP, DW, BY ...
    filter(!.data$monogram %in% stop.words$word) %>%
    # eliminate words that are just numbers
    filter(!grepl('^\\d', .data$monogram)) %>%
    # group by cluster and count how many words
    group_by(.data$Cluster, .data$Enrichment) %>%
    count(.data$monogram, sort = TRUE)

}

#' @title gm_enrichterms: GSEAmining enriched terms
#'
#' @description Takes the output of gm_clust, which is an hclust class object,
#' and plots gene set enriched terms as wordclouds. Two options are available,
#' either separate enrichments by clusters or plot them together in a single
#' plot.
#'
#' @param df Data frame that contains at least three columns: an ID column for
#' the gene set names, a NES column with the normalized enrichment score and a
#' core_enrichment column containing the genes in the leading edge of each
#' gene set separated by '/'.
#' @param hc The output of gm_clust, which is an hclust class object.
#' @param clust A logical value indicating if wordclouds should be separated by
#' clusters or not. Default value is TRUE.
#' @param col_pos Color to represent positively enriched gene sets. Default
#' is red.
#' @param col_neg Color to represent negatively enriched gene sets. Default
#' is blue.
#'
#' @return Returns a ggplot object.
#'
#' @export
#'
#' @import stringr
#' @import ggwordcloud
#' @import ggplot2
#'
#' @examples
#' data(genesets_sel)
#' gs.cl <- gm_clust(genesets_sel)
#' gm_enrichterms(genesets_sel, gs.cl)
#'
gm_enrichterms <- function(df,
                           hc,
                           clust = TRUE,
                           col_pos = 'red',
                           col_neg = 'blue') {

  stopifnot(is.data.frame(df) | methods::is(hc, 'hclust'))

  # Get the cluster groups from  gm_clust object ------------------------------
  clust.groups <- clust_groups(df, hc)

  # Obtain the terms of each gene set -----------------------------------------
  clust.groups.wordcloud <- clust_group_terms(clust.groups)

  # Plot enriched terms wordclouds using ggwordcloud --------------------------
  plot <- ggplot(clust.groups.wordcloud,
                 aes(label = .data$monogram,
                     size = .data$n,
                     col = .data$Enrichment)) +
    # rm_outside option eliminates words that do not fit in the image
    ggwordcloud::geom_text_wordcloud_area(eccentricity = 1,
                                          area_corr_power = 1,
                                          rm_outside = TRUE) +
    scale_color_manual(values = c(col_neg, col_pos)) +
    scale_size_area(max_size = 8) +
    theme_minimal() +
    theme(plot.title = element_text(hjust = 0.5),
          strip.text = element_text(face = 'bold'))

  # Plot text title and facets depending on clustering parameter --------------
  if (clust == TRUE) {
    plot +
      ggtitle('Gene Sets Enriched Terms  by Cluster') +
      facet_wrap(Enrichment ~ Cluster,
                 labeller = label_both)
  } else {
    plot +
      ggtitle('Gene Sets Enriched Terms')
  }

}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----eval=FALSE---------------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("GSEAmining")

## ----eval=FALSE---------------------------------------------------------------
# install.packages("devtools") # If you have not installed "devtools" package
# library(devtools)
# devtools::install_github("oriolarques/GSEAmining")

## ----eval=FALSE---------------------------------------------------------------
# # A geneList contains three features:
# # 1.numeric vector: fold change or other type of numerical variable
# # 2.named vector: every number has a name, the corresponding gene ID
# # 3.sorted vector: number should be sorted in decreasing order
# tableTop_p30 <- as.data.frame(tableTop_p30)
# geneList = tableTop_p30[,2]
# names(geneList) = as.character(tableTop_p30[,1])

## ----eval=FALSE---------------------------------------------------------------
# library(clusterProfiler)
# # Read the .gmt file from MSigDB
# gmtC2<- read.gmt("gmt files/c2.all.v7.1.symbols.gmt")
# gmtC5<- read.gmt('gmt files/c5.all.v7.1.symbols.gmt')
# gmtHALL <- read.gmt('gmt files/h.all.v7.1.symbols.gmt')
# 
# # Merge all the gene sets
# gmt_all <- rbind(gmtC2, gmtC5, gmtHALL)

## ----eval=FALSE---------------------------------------------------------------
# GSEA_p30<-GSEA(geneList, TERM2GENE = gmt_all, nPerm = 1000, pvalueCutoff = 0.5)
# 
# # Selection of gene sets with a specific thershold in terms of NES and p.adjust
# genesets_sel <- GSEA_p30@result

## -----------------------------------------------------------------------------
# Structure of the data included in the package
data('genesets_sel', package = 'GSEAmining')
tibble::glimpse(genesets_sel)

## -----------------------------------------------------------------------------
library(GSEAmining)
data("genesets_sel", package = 'GSEAmining')
gs.filt <- gm_filter(genesets_sel, 
                     p.adj = 0.05, 
                     neg_NES = 2.6, 
                     pos_NES = 2)

## ----setup--------------------------------------------------------------------
# Create an object that will contain the cluster of gene sets.
gs.cl <- gm_clust(gs.filt)

## ----fig.height = 7, fig.width = 7--------------------------------------------
gm_dendplot(gs.filt, 
            gs.cl)

## ----fig.height = 7, fig.width = 7--------------------------------------------
gm_dendplot(gs.filt, 
            gs.cl, 
            col_pos = 'orange', 
            col_neg = 'black', 
            rect = TRUE,
            dend_len = 20, 
            rect_len = 2)


## ----message = FALSE, fig.height = 7, fig.width = 7---------------------------
gm_enrichterms(gs.filt, gs.cl)

## ----message = FALSE, fig.height = 7, fig.width = 7---------------------------
gm_enrichterms(gs.filt, 
               gs.cl, 
               clust = FALSE,
               col_pos = 'chocolate3',
               col_neg = 'skyblue3')

## ----message = FALSE, fig.height = 12, fig.width = 7.2------------------------
gm_enrichcores(gs.filt, gs.cl)

## ----eval=FALSE---------------------------------------------------------------
# gm_enrichreport(gs.filt, gs.cl, output = 'gm_report')

## -----------------------------------------------------------------------------
sessionInfo()

#' @title clust_groups
#'
#' @description Takes the output of gm_clust, which is an hclust class object,
#' and returns a data frame that will be used in the rest of GSEAmining
#' functions gm_enrichreport, gm_enrichterms and gm_enrichcores.
#'
#' @param df Data frame that contains at least three columns: an ID column for
#' the gene set names, a NES column with the normalized enrichment score and a
#' core_enrichment column containing the genes in the leading edge of each
#' gene set separated by '/'.
#' @param hc The output of gm_clust, which is an hclust class object.
#'
#' @return A data.frame containing the cluster each gene set belongs to.
#'
#' @export
#'
#' @examples
#' data(genesets_sel)
#' gs.cl <- gm_clust(genesets_sel)
#' clust.groups <- clust_groups(genesets_sel, gs.cl)
#'
clust_groups <- function(df,
                         hc) {

  # Get the cluster groups from  gm_clust object ------------------------------
  clust_groups <- data.frame(Cluster=cutree(hc, h = 0.999)) %>%
    rownames_to_column('ID') %>%
    arrange(.data$Cluster) %>%
    left_join(df, by='ID')

}

#' Selected gene sets as test
#'
#' Data that corresponds to GSEA analysis of differential expressed genes from
#' treated versus control samples in HGPalmer-PDX-P30 experiment. Differential
#' gene expression was obtained by using the oligo and limma R packages. GSEA
#' analysis was performed using the clusterProfiler R package using MSigDb
#' collections C2, C5 and Hallmarks.
#'
#' @docType data
#'
#' @usage data(genesets_sel)
#'
#' @format An object of class data.frame with 52 observations and 4 variables:
#' \describe{
#'     \item{ID}{Name of the gene set}
#'     \item{NES}{Normalized Enrichment Score}
#'     \item{p.adjust}{False discovery rate}
#'     \item{core_enrichment}{Genes that are in the leading edge subset}
#' }
#'
#' @references Arqués et al. Clinical Cancer Research. 2016 Feb 1;22(3):644-56.
#' doi: 10.1158/1078-0432.CCR-14-3081. Epub 2015 Jul 29.
#' (\href{https://clincancerres.aacrjournals.org/content/22/3/644.long}{Clinical Cancer Research})
#'
#' @source \href{https://www.ebi.ac.uk/arrayexpress/experiments/E-MTAB-2446/}{ArrayExpress}
#'
#' @examples
#' data(genesets_sel)
#'
#' gs.cl <- gm_clust(genesets_sel)
#'
#' gm_dendplot(genesets_sel, gs.cl)
#'
#' gm_enrichterms(genesets_sel, gs.cl)
#'
#' gm_enrichcores(genesets_sel, gs.cl)
#'
#' \dontrun{gm_enrichreport(genesets_sel, gs.cl)}
#'
"genesets_sel"

#' @title gm_clust: GSEAmining cluster object
#'
#' @description Takes the output of gm_filter or a data frame that with the
#' results of GSEA analysis and returns and hclust object that can be plotted
#' using the gm_dendplot function.
#'
#'
#' @param df Data frame that contains at least three columns: an ID column for
#' the gene set names, a NES column with the normalized enrichment score and a
#' core_enrichment column containing the genes in the leading edge of each
#' gene set separated by '/'.
#'
#'
#' @return An object of class hclust that contains the clustering of the gene
#' sets by the core enriched genes.First a distance matrix is calculated
#' using the 'binary' method and then a cluster with the 'complete' method is
#' created.
#'
#' @export
#'
#' @import dplyr
#' @import tidytext
#' @importFrom stats dist
#' @importFrom stats hclust
#' @importFrom rlang .data
#'
#' @examples
#' data(genesets_sel)
#' gs.cl <- gm_clust(genesets_sel)
#'
#'
gm_clust <- function(df) {

  stopifnot(is.data.frame(df))

  # Create a table where all leading edge genes are in rows -------------------
  gsea_tokens <- df %>%
    tidytext::unnest_tokens(output = .data$lead_genes,
                            input = .data$core_enrichment,
                            to_lower = FALSE) %>%
    group_by(.data$ID) %>%
    count(.data$lead_genes)

  # Casting tidytext data into a matrix ---------------------------------------
  cast_matrix <- cast_dtm(data = gsea_tokens,
                          document = .data$ID,
                          term = .data$lead_genes,
                          value = n)

  # Hierarchical clustering ---------------------------------------------------
  distance_matrix <- dist(cast_matrix, method = 'binary')

  hc <- hclust(distance_matrix)

}

library("GSEAmining")
data(genesets_sel)

test_that("Test that gm_clust produces an hclust object", {

  gs.filt <- gm_filter(genesets_sel,
                       p.adj = 0.05,
                       neg_NES = 2.6,
                       pos_NES = 2)
  gs.cl <- gm_clust(gs.filt)

  expect_equal(class(gs.cl), 'hclust')
  expect_equal(length(gs.cl), 7)

})

#' Stop words.
#' Eliminates the first word of the gene sets from MSigDb that relate to the
#' origin of the gene set. Additionally it eliminates words that do not add
#' a lot of significance such as prepositions or adverbs among others.
#'
#' @return Returns a tibble with 2 variables.
#'
#' @export
#'
#'
stop_words <- function() {
  return(tribble(
  ~word, ~lexicon,
  'REACTOME', "CUSTOM",
  'HALLMARK', "CUSTOM",
  'KEGG', "CUSTOM",
  'BIOCARTA', "CUSTOM",
  'PID', "CUSTOM",
  'TARGETS', "CUSTOM",
  'RESPONSE', "CUSTOM",
  'PATHWAY', "CUSTOM",
  'GO', "CUSTOM",
  'OF', "CUSTOM",
  'BY', "CUSTOM",
  'AND', "CUSTOM",
  'THE', "CUSTOM",
  'IN', "CUSTOM",
  'TO', "CUSTOM",
  'UP', "CUSTOM",
  'DN', "CUSTOM",
  'OF', "CUSTOM",
  'VS', "CUSTOM",
  'OR', "CUSTOM",
  'AT', "CUSTOM",
  'REGULATION', "CUSTOM",
  'PROCESS', "CUSTOM",
  'POSITIVE', "CUSTOM",
  'NEGATIVE', "CUSTOM",
  'FROM', "CUSTOM",
  'INTO', "CUSTOM",
  'UNKNOWN', "CUSTOM",
  'MODULE', "CUSTOM",
  '1HR', "CUSTOM",
  '2HR', "CUSTOM",
  '4HR', "CUSTOM",
  '6HR', "CUSTOM",
  '8HR', "CUSTOM",
  '10HR', "CUSTOM",
  '12HR', "CUSTOM",
  '14HR', "CUSTOM",
  '16HR', "CUSTOM",
  '18HR', "CUSTOM",
  '20HR', "CUSTOM",
  '24HR', "CUSTOM",
  '48HR', "CUSTOM",
  '96HR', "CUSTOM"))
}

#' @title gm_enrichcores: GSEAmining core enrichment genes
#'
#' @description Takes the output of gm_clust, which is an hclust class object,
#' and plots the top n genes in core enrichment (leading edge analysis).
#' Two options are available, either separate barplots by clusters or all
#' together in one plot.
#'
#' @param df Data frame that contains at least three columns: an ID column for
#' the gene set names, a NES column with the normalized enrichment score and a
#' core_enrichment column containing the genes in the leading edge of each
#' gene set separated by '/'.
#' @param hc The output of gm_clust, which is an hclust class object.
#' @param clust A logical value indicating if wordclouds should be separated by
#' clusters or not. Default value is TRUE.
#' @param col_pos Color to represent positively enriched gene sets. Default
#' is red.
#' @param col_neg Color to represent negatively enriched gene sets. Default
#' is blue.
#' @param top An integer to choose the top most enriched genes to plot per
#' cluster. The default parameter are the top 3.
#'
#' @return Returns a ggplot object.
#'
#' @export
#'
#' @importFrom grDevices rgb
#' @importFrom graphics par
#'
#' @examples
#' data(genesets_sel)
#' gs.cl <- gm_clust(genesets_sel)
#' gm_enrichcores(genesets_sel, gs.cl)
#'
gm_enrichcores <- function(df,
                           hc,
                           clust = TRUE,
                           col_pos = 'red',
                           col_neg = 'blue',
                           top = 3) {

  stopifnot(is.data.frame(df) | methods::is(hc, 'hclust'))

  # Get the cluster groups from  gm_clust object ------------------------------
  clust.groups <- clust_groups(df, hc)

  # Obtain core enrichment terms of each gene set -----------------------------
  clust.lead <- clust_group_cores(clust.groups, top)

  # Bar plot of top n core enrichment gens ------------------------------------
  plot <- ggplot(clust.lead,
                 aes(x = stats::reorder(.data$lead_token, .data$n),
                     y = .data$n,
                     fill = .data$Enrichment)) +
    geom_bar(stat = 'identity') +
    coord_flip() +
    scale_fill_manual(values = c(col_neg, col_pos)) +
    scale_y_continuous(expand = c(0, 0)) +
    ylab('Num of Gene Appearances in Different Genesets') +
    theme_minimal() +
    theme(plot.title = element_text(hjust = 0.5),
          axis.title.y = element_blank(),
          axis.line.x = element_line(),
          axis.line.y = element_line(),
          panel.grid.major.y = element_blank(),
          strip.text = element_text(face = 'bold'))

  if (clust == TRUE) {
    plot +
      ggtitle('Top Genes in Leading Edge Analysis by Cluster') +
      theme(legend.position = 'none') +
      facet_wrap(Enrichment ~ Cluster,
                 labeller= label_both,
                 scales = 'free_y')
  } else {
    plot +
      ggtitle('Top Genes in Leading Edge Analysis')
  }

}

#' @title gm_filter: GSEAmining GSEA output filter
#'
#' @description Filters a data frame containing the results of GSEA analysis.
#'
#' @param df Data frame that contains at least three columns: an ID column for
#' the gene set names, a NES column with the normalized enrichment score and a
#' core_enrichment column containing the genes in the leading edge of each
#' gene set separated by '/'.
#' @param p.adj An integer to set the limit of the adjusted p-value (or false
#' discovery rate, FDR). Default value is 0.05
#' @param neg_NES A positive integer to set the limit of negative NES. Default
#' is 1.
#' @param pos_NES A positive integer to set the limit of positive NES. Default
#' is 1.
#'
#' @return A data frame.
#' @export
#'
#' @import dplyr
#'
#' @examples
#' data(genesets_sel)
#' gs.filt <- gm_filter(genesets_sel, p.adj = 0.05, neg_NES = 2.6, pos_NES = 2)
#'
gm_filter <- function(df,
                      p.adj = 0.05,
                      neg_NES = 1,
                      pos_NES = 1) {
  df %>%
    dplyr::arrange(desc(.data$NES)) %>%
    dplyr::filter((.data$p.adjust < p.adj & .data$NES < - neg_NES) |
                    (.data$p.adjust < p.adj & .data$NES > pos_NES)) %>%
    dplyr::select(.data$ID, .data$NES, .data$p.adjust, .data$core_enrichment)
}

library("GSEAmining")
data(genesets_sel)

test_that("Test that gm_filter produces a data.frame with the 4 correct
          columns", {

  gs.filt <- gm_filter(genesets_sel,
                       p.adj = 0.05,
                       neg_NES = 2.6,
                       pos_NES = 2)

  expect_equal(class(gs.filt), 'data.frame')
  expect_equal(names(gs.filt), c("ID", "NES", "p.adjust", "core_enrichment"))

})

---
title: "GSEAmining"
author: "Oriol Arqués"
package: GSEAmining
date: '7 May 2020'
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{GSEAmining}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Overview
Gene Set Enrichment Analysis 
([GSEA](https://www.gsea-msigdb.org/gsea/doc/GSEAUserGuideFrame.html)) 
is a very powerful and interesting computational method that allows an easy 
correlation between differential expressed genes and biological processes. 
Unfortunately, although it was designed to help researchers to interpret gene
expression data it can generate huge amounts of results whose biological 
meaning can be difficult to interpret. 

Many available tools rely on the hierarchically structured Gene Ontology (GO) 
classification to reduce reundandcy in the results. However, due to the 
popularity of GSEA many more gene set collections, such as those in the 
Molecular Signatures Database 
([MSigDB](https://www.gsea-msigdb.org/gsea/msigdb/index.jsp)), 
are emerging. Since these collections 
are not organized as those in GO, their usage for GSEA do not always give a 
straightforward answer or, in other words, getting all the meaninful information
can be challenging with the currently available tools. For these reasons, 
GSEAmining was born to be an easy tool to create reproducible reports to help 
researchers make biological sense of GSEA outputs.

Given the results of GSEA, GSEAmining clusters the different gene sets 
collections based on the presence of the same genes in the leadind edge 
(core) subset. Leading edge subsets are those genes that contribute most to the 
enrichment score of each collection of genes or gene sets. For this reason, 
gene sets that participate in similar biological processes should share genes 
in common and in turn cluster together. After that, GSEAmining is able to 
identify and represent for each cluster: 

- The most enriched terms in the names of gene sets (as word clouds)
- The most enriched genes in the leading edge subsets (as bar plots).

In each case, positive and negative enrichments are shown in different colors 
so it is easy to distinguish biological processes or genes that may be of 
interest in that particular study.

# Installation
You can install `GSEAmining` from Bioconductor:
```{r, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("GSEAmining")
```

Or directly from GitHub:
```{r, eval=FALSE}
install.packages("devtools") # If you have not installed "devtools" package
library(devtools)
devtools::install_github("oriolarques/GSEAmining")
```

# Input data format: gm_filter
By default GSEAmining is designed to accept the resuls of the GSEA function
from the [clusterProfiler](https://bioconductor.org/packages/release/bioc/html/clusterProfiler.html) 
package. For more information about this function click 
[here](https://yulab-smu.github.io/clusterProfiler-book/chapter7.html). However,
it is *not mandatory to use this package*.

In this example the data corresponds to GSEA analysis of differential expressed 
genes from treated versus control samples in 
[HGPalmer-PDX-P30 experiment](https://www.ebi.ac.uk/arrayexpress/experiments/E-MTAB-2446/).
Differential gene expression (tableTop) was obtained using the oligo and limma R 
packages.

- Generation of a geneList, which is a ranked list of all the genes, 
for GSEA using clusterProfiler.
```{r, eval=FALSE}
# A geneList contains three features:
# 1.numeric vector: fold change or other type of numerical variable
# 2.named vector: every number has a name, the corresponding gene ID
# 3.sorted vector: number should be sorted in decreasing order
tableTop_p30 <- as.data.frame(tableTop_p30)
geneList = tableTop_p30[,2]
names(geneList) = as.character(tableTop_p30[,1])
```

- Gmt files containing the different gene sets that will be analysed by GSEA. They
can be downloaded from the
[MSigDB](https://www.gsea-msigdb.org/gsea/downloads.jsp)
```{r, eval=FALSE}
library(clusterProfiler)
# Read the .gmt file from MSigDB
gmtC2<- read.gmt("gmt files/c2.all.v7.1.symbols.gmt")
gmtC5<- read.gmt('gmt files/c5.all.v7.1.symbols.gmt')
gmtHALL <- read.gmt('gmt files/h.all.v7.1.symbols.gmt')

# Merge all the gene sets
gmt_all <- rbind(gmtC2, gmtC5, gmtHALL)
```

- Perform the GSEA.
```{r, eval=FALSE}
GSEA_p30<-GSEA(geneList, TERM2GENE = gmt_all, nPerm = 1000, pvalueCutoff = 0.5)

# Selection of gene sets with a specific thershold in terms of NES and p.adjust
genesets_sel <- GSEA_p30@result
```


Data should be in a data.frame with, **at least** three columns labelled as 
follows:

- **ID**: The name of the gene set.

- **NES**: Normalized Enrichment Score of the gene set.

- **core_enrichment**: Genes that appear in the leading edge subset of the gene
set.

```{r}
# Structure of the data included in the package
data('genesets_sel', package = 'GSEAmining')
tibble::glimpse(genesets_sel)
```

**gm_filter: Filter the input data**

GSEA outputs normally presents tens or hundreds of genesets but many of them 
may not meet the thresholds for considering them significantly enriched. For 
that it is better to filter the data for a better visualization.

The `gm_filter()` function of GSEAmining allows this process to be very easy, 
especially if the format of your data meets the aforementioned criteria.

```{r}
library(GSEAmining)
data("genesets_sel", package = 'GSEAmining')
gs.filt <- gm_filter(genesets_sel, 
                     p.adj = 0.05, 
                     neg_NES = 2.6, 
                     pos_NES = 2)
```

# Clustering
## gm_clust: Creation of a gm_clust object
Using the `gm_clust()` function, we can create an object that will contain the 
hierarchical clustering of the gene sets according to their genes in the 
core_enrichment column. This function accepts the data frame created with 
gm_filter. In the process, a distance matrix  is calculated using the 
*binary* method (from the `dist()` function in `stats`) and then a cluster with 
the *complete* method (from `hclust()` function in `stats`) is created.

```{r setup}
# Create an object that will contain the cluster of gene sets.
gs.cl <- gm_clust(gs.filt)
```

## gm_dendplot: Plot the cluster
The `gm_dendplot()` function uses (i) the filtered data frame and (ii) the 
gm_clust object to plot the cluster dendrogram. It shows which gene sets are
positively or negatively enriched coloring them in red or blue respectively. 
Additionally by default the function will highlight every other cluster with a
rectangle to facilitate the differentiation of all the clusters.

```{r, fig.height = 7, fig.width = 7}
gm_dendplot(gs.filt, 
            gs.cl)
```

It is possible to tune the height of the dendrogram, the colors for the 
enrichment and the use of rectangles (and their sizes) for highlighting 
clusters.

```{r, fig.height = 7, fig.width = 7}
gm_dendplot(gs.filt, 
            gs.cl, 
            col_pos = 'orange', 
            col_neg = 'black', 
            rect = TRUE,
            dend_len = 20, 
            rect_len = 2)

```

# Evaluation of gene sets enriched terms by cluster
To start getting an idea of what kind of biological processes are represented
in each cluster we can use `gm_enrichterms()`. This function plots word clouds
for the most enriched terms in the names of the different gene sets in each 
cluster. Again it needs (i) the filtered data frame and (ii) the gm_clust 
object created before. By default Positive or negative enrichment are colored 
in red or in blue respectively and two ploting options are available:

- By cluster:
```{r, message = FALSE, fig.height = 7, fig.width = 7}
gm_enrichterms(gs.filt, gs.cl)
```
- Without clustering:
```{r, message = FALSE, fig.height = 7, fig.width = 7}
gm_enrichterms(gs.filt, 
               gs.cl, 
               clust = FALSE,
               col_pos = 'chocolate3',
               col_neg = 'skyblue3')
```

# Evaluation of gene enrichment in leading edge subsets by clusters
As for the gene set terms, it is also possible to evaluate which are the most
enriched genes in the leading edge (or core enrichment) subsets in the
different clusters with the function `gm_enrichcores()`. In this case the 
representation is shown as bar plots following the same options as in
`gm_enrichterms()` regarding colors and clustering the results. 

```{r, message = FALSE, fig.height = 12, fig.width = 7.2}
gm_enrichcores(gs.filt, gs.cl)
```

Additionally, this function allows the possibility to
decide the number of the most top genes that will be plotted using the parameter
`top`. In case more than the indicated number of top genes appear the same 
number of times in the same cluster they all will be shown.

# gm_enrichreport: Create a report
Finally, the `gm_enrichreport()` is a tool that generates a pdf file where each
page contains both the terms word cloud and the leading edge bar plot for each of
the different clusters in the gm_clust object. 

```{r, eval=FALSE}
gm_enrichreport(gs.filt, gs.cl, output = 'gm_report')
```

The `output`parameter can be used to name the file that will be generated (by
default it will be called gm_report.pdf). As in the previous functions the
colors and the number of top genes are also editable parameters of the function.

# SessionInfo()
```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gm_filter.R
\name{gm_filter}
\alias{gm_filter}
\title{gm_filter: GSEAmining GSEA output filter}
\usage{
gm_filter(df, p.adj = 0.05, neg_NES = 1, pos_NES = 1)
}
\arguments{
\item{df}{Data frame that contains at least three columns: an ID column for
the gene set names, a NES column with the normalized enrichment score and a
core_enrichment column containing the genes in the leading edge of each
gene set separated by '/'.}

\item{p.adj}{An integer to set the limit of the adjusted p-value (or false
discovery rate, FDR). Default value is 0.05}

\item{neg_NES}{A positive integer to set the limit of negative NES. Default
is 1.}

\item{pos_NES}{A positive integer to set the limit of positive NES. Default
is 1.}
}
\value{
A data frame.
}
\description{
Filters a data frame containing the results of GSEA analysis.
}
\examples{
data(genesets_sel)
gs.filt <- gm_filter(genesets_sel, p.adj = 0.05, neg_NES = 2.6, pos_NES = 2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stop_words.R
\name{stop_words}
\alias{stop_words}
\title{Stop words.
Eliminates the first word of the gene sets from MSigDb that relate to the
origin of the gene set. Additionally it eliminates words that do not add
a lot of significance such as prepositions or adverbs among others.}
\usage{
stop_words()
}
\value{
Returns a tibble with 2 variables.
}
\description{
Stop words.
Eliminates the first word of the gene sets from MSigDb that relate to the
origin of the gene set. Additionally it eliminates words that do not add
a lot of significance such as prepositions or adverbs among others.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clust_groups.R
\name{clust_groups}
\alias{clust_groups}
\title{clust_groups}
\usage{
clust_groups(df, hc)
}
\arguments{
\item{df}{Data frame that contains at least three columns: an ID column for
the gene set names, a NES column with the normalized enrichment score and a
core_enrichment column containing the genes in the leading edge of each
gene set separated by '/'.}

\item{hc}{The output of gm_clust, which is an hclust class object.}
}
\value{
A data.frame containing the cluster each gene set belongs to.
}
\description{
Takes the output of gm_clust, which is an hclust class object,
and returns a data frame that will be used in the rest of GSEAmining
functions gm_enrichreport, gm_enrichterms and gm_enrichcores.
}
\examples{
data(genesets_sel)
gs.cl <- gm_clust(genesets_sel)
clust.groups <- clust_groups(genesets_sel, gs.cl)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gm_enrichcores.R
\name{gm_enrichcores}
\alias{gm_enrichcores}
\title{gm_enrichcores: GSEAmining core enrichment genes}
\usage{
gm_enrichcores(
  df,
  hc,
  clust = TRUE,
  col_pos = "red",
  col_neg = "blue",
  top = 3
)
}
\arguments{
\item{df}{Data frame that contains at least three columns: an ID column for
the gene set names, a NES column with the normalized enrichment score and a
core_enrichment column containing the genes in the leading edge of each
gene set separated by '/'.}

\item{hc}{The output of gm_clust, which is an hclust class object.}

\item{clust}{A logical value indicating if wordclouds should be separated by
clusters or not. Default value is TRUE.}

\item{col_pos}{Color to represent positively enriched gene sets. Default
is red.}

\item{col_neg}{Color to represent negatively enriched gene sets. Default
is blue.}

\item{top}{An integer to choose the top most enriched genes to plot per
cluster. The default parameter are the top 3.}
}
\value{
Returns a ggplot object.
}
\description{
Takes the output of gm_clust, which is an hclust class object,
and plots the top n genes in core enrichment (leading edge analysis).
Two options are available, either separate barplots by clusters or all
together in one plot.
}
\examples{
data(genesets_sel)
gs.cl <- gm_clust(genesets_sel)
gm_enrichcores(genesets_sel, gs.cl)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gm_enrichterms.R
\name{gm_enrichterms}
\alias{gm_enrichterms}
\title{gm_enrichterms: GSEAmining enriched terms}
\usage{
gm_enrichterms(df, hc, clust = TRUE, col_pos = "red", col_neg = "blue")
}
\arguments{
\item{df}{Data frame that contains at least three columns: an ID column for
the gene set names, a NES column with the normalized enrichment score and a
core_enrichment column containing the genes in the leading edge of each
gene set separated by '/'.}

\item{hc}{The output of gm_clust, which is an hclust class object.}

\item{clust}{A logical value indicating if wordclouds should be separated by
clusters or not. Default value is TRUE.}

\item{col_pos}{Color to represent positively enriched gene sets. Default
is red.}

\item{col_neg}{Color to represent negatively enriched gene sets. Default
is blue.}
}
\value{
Returns a ggplot object.
}
\description{
Takes the output of gm_clust, which is an hclust class object,
and plots gene set enriched terms as wordclouds. Two options are available,
either separate enrichments by clusters or plot them together in a single
plot.
}
\examples{
data(genesets_sel)
gs.cl <- gm_clust(genesets_sel)
gm_enrichterms(genesets_sel, gs.cl)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gm_enrichreport.R
\name{gm_enrichreport}
\alias{gm_enrichreport}
\title{gm_enrichreport: GSEAmining Enrichment Report}
\usage{
gm_enrichreport(
  df,
  hc,
  col_pos = "red",
  col_neg = "blue",
  top = 3,
  output = "gm_report"
)
}
\arguments{
\item{df}{Data frame that contains at least three columns: an ID column for
the gene set names, a NES column with the normalized enrichment score and a
core_enrichment column containing the genes in the leading edge of each
gene set separated by '/'.}

\item{hc}{The output of gm_clust, which is an hclust class object.}

\item{col_pos}{Color to represent positively enriched gene sets. Default
is red.}

\item{col_neg}{Color to represent negatively enriched gene sets. Default
is blue.}

\item{top}{An integer to choose the top most enriched genes to plot per
cluster. The default parameter are the top 3.}

\item{output}{A string to name the output pdf file.}
}
\value{
Generates a pdf file.
}
\description{
Takes the output of gm_clust, which is an hclust class object,
and creates a report in pdf that contains enriched terms and enriched core
genes in gene sets for each cluster. The results of each cluster are plotted
in an independent page.
}
\examples{
#' data(genesets_sel)
gs.cl <- gm_clust(genesets_sel)
\dontrun{gm_enrichreport(genesets_sel, gs.cl)}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gm_clust.R
\name{gm_clust}
\alias{gm_clust}
\title{gm_clust: GSEAmining cluster object}
\usage{
gm_clust(df)
}
\arguments{
\item{df}{Data frame that contains at least three columns: an ID column for
the gene set names, a NES column with the normalized enrichment score and a
core_enrichment column containing the genes in the leading edge of each
gene set separated by '/'.}
}
\value{
An object of class hclust that contains the clustering of the gene
sets by the core enriched genes.First a distance matrix is calculated
using the 'binary' method and then a cluster with the 'complete' method is
created.
}
\description{
Takes the output of gm_filter or a data frame that with the
results of GSEA analysis and returns and hclust object that can be plotted
using the gm_dendplot function.
}
\examples{
data(genesets_sel)
gs.cl <- gm_clust(genesets_sel)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gm_dendplot.R
\name{gm_dendplot}
\alias{gm_dendplot}
\title{gm_dendplot: GSEAmining dendrogram plotter}
\usage{
gm_dendplot(
  df,
  hc,
  col_pos = "red",
  col_neg = "blue",
  dend_len = 30,
  rect = TRUE,
  rect_len = 2
)
}
\arguments{
\item{df}{Data frame that contains at least three columns: an ID column for
the gene set names, a NES column with the normalized enrichment score and a
core_enrichment column containing the genes in the leading edge of each
gene set separated by '/'.}

\item{hc}{The output of gm_clust, which is an hclust class object.}

\item{col_pos}{Color to represent the positively enriched gene sets. Default
is red.}

\item{col_neg}{Color to represent the negatively enriched gene sets. Default
is blue.}

\item{dend_len}{An integer that defines the length of the dendrogram. Default
value is 30. The closest to zero the longest the dendrogram.}

\item{rect}{A logical value indicating if rectangles should be drawn around
the clusters to help differentiating them. By default it is set to TRUE.}

\item{rect_len}{An integer to specify the length of the rectangle around the
cluster and the gene set label. Default is 2. The closest to zero the
smallest the rectangle.}
}
\value{
Invisibly returns a list with all the elements necessary to plot
a dendrogram.
}
\description{
Takes the output of gm_clust, which is an hclust class object,
and plots the dendrogram using the dendextend package.
}
\examples{
data(genesets_sel)
gs.cl <- gm_clust(genesets_sel)
gm_dendplot(genesets_sel, gs.cl)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genesets_sel-data.R
\docType{data}
\name{genesets_sel}
\alias{genesets_sel}
\title{Selected gene sets as test}
\format{
An object of class data.frame with 52 observations and 4 variables:
\describe{
    \item{ID}{Name of the gene set}
    \item{NES}{Normalized Enrichment Score}
    \item{p.adjust}{False discovery rate}
    \item{core_enrichment}{Genes that are in the leading edge subset}
}
}
\source{
\href{https://www.ebi.ac.uk/arrayexpress/experiments/E-MTAB-2446/}{ArrayExpress}
}
\usage{
data(genesets_sel)
}
\description{
Data that corresponds to GSEA analysis of differential expressed genes from
treated versus control samples in HGPalmer-PDX-P30 experiment. Differential
gene expression was obtained by using the oligo and limma R packages. GSEA
analysis was performed using the clusterProfiler R package using MSigDb
collections C2, C5 and Hallmarks.
}
\examples{
data(genesets_sel)

gs.cl <- gm_clust(genesets_sel)

gm_dendplot(genesets_sel, gs.cl)

gm_enrichterms(genesets_sel, gs.cl)

gm_enrichcores(genesets_sel, gs.cl)

\dontrun{gm_enrichreport(genesets_sel, gs.cl)}

}
\references{
Arqués et al. Clinical Cancer Research. 2016 Feb 1;22(3):644-56.
doi: 10.1158/1078-0432.CCR-14-3081. Epub 2015 Jul 29.
(\href{https://clincancerres.aacrjournals.org/content/22/3/644.long}{Clinical Cancer Research})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clust_group_cores.R
\name{clust_group_cores}
\alias{clust_group_cores}
\title{clust_group_cores}
\usage{
clust_group_cores(cg, top = 3)
}
\arguments{
\item{cg}{A data frame output from the GSEAmining clusts_groups function.}

\item{top}{An integer to choose the top most enriched genes to plot per
cluster. The default parameter are the top 3.}
}
\value{
A tibble with four variables (Cluster, Enrichment, lead_token, n).
}
\description{
Takes the output of clust_groups, a data frame , and process
it to obtain the enrichment of genes in the core enrichment (or leading
edge analysis) within each cluster. The output is used in the functions
gm_enrichcores and gm_enrichreport.
}
\examples{
data(genesets_sel)
gs.cl <- gm_clust(genesets_sel)
clust.groups <- clust_groups(genesets_sel, gs.cl)
clust.lead <- clust_group_cores(clust.groups, top = 3)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clust_group_terms.R
\name{clust_group_terms}
\alias{clust_group_terms}
\title{clust_group_terms}
\usage{
clust_group_terms(cg)
}
\arguments{
\item{cg}{A data frame output from the GSEAmining cluster_groups function.}
}
\value{
A tibble with four variables (Cluster, Enrichment, monogram, n).
}
\description{
Takes the output of clust_groups, a data frame , and process
it to obtain the enrichment of terms in gene sets names within each cluster.
The output is used in the functions gm_enrichterms and gm_enrichreport.
}
\examples{
data(genesets_sel)
gs.cl <- gm_clust(genesets_sel)
clust.groups <- clust_groups(genesets_sel, gs.cl)
clust.groups.wordcloud <- clust_group_terms(clust.groups)

}
